QT -= core \
    gui
DESTDIR = build
OBJECTS_DIR = src
TARGET = Lephisto
LIBS += -lGL \
    -lGLU \
    -lSDL \
    -lSDL_image
CONFIG += warn_on \
    x11 \
    opengl
SOURCES += src/Camera.cpp \
    src/City.cpp \
    src/CityManager.cpp \
    src/collisions.cpp \
    src/Config.cpp \
    src/EnvironmentObject.cpp \
    src/extensions.cpp \
    src/font.cpp \
    src/Frustum.cpp \
    src/GameState.cpp \
    src/image.cpp \
    src/Log.cpp \
    src/main.cpp \
    src/MainMenu.cpp \
    src/Map.cpp \
    src/normals.cpp \
    src/Ocean.cpp \
    src/Player.cpp \
    src/Point.cpp \
    src/QuadBox.cpp \
    src/QuadNode.cpp \
    src/StateCity.cpp \
    src/StateSailing.cpp \
    src/Terrain.cpp \
    src/tinyxmlparser.cpp \
    src/tinyxmlerror.cpp \
    src/tinyxml.cpp \
    src/tinystr.cpp \
    src/Wave.cpp \
    src/WaveEmitter.cpp \
    src/BoundBox.cpp \
    src/Model.cpp \
    src/Product.cpp \
    src/Economy.cpp \
    src/CityEconomy.cpp \
    src/SkyBox.cpp \
    src/Menu.cpp \
    src/StateBattle.cpp \
    src/Ships.cpp \
    src/WaveEmitter.cpp \
    src/Wave.cpp \
    src/tinyxmlparser.cpp \
    src/tinyxmlerror.cpp \
    src/tinyxml.cpp \
    src/tinystr.cpp \
    src/Terrain.cpp \
    src/StateSailing.cpp \
    src/StateCity.cpp \
    src/StateBattle.cpp \
    src/sound.cpp \
    src/SkyBox.cpp \
    src/Ships.cpp \
    src/QuadNode.cpp \
    src/QuadBox.cpp \
    src/Product.cpp \
    src/Point.cpp \
    src/Player.cpp \
    src/Ocean.cpp \
    src/normals.cpp \
    src/Model.cpp \
    src/Menu.cpp \
    src/Map.cpp \
    src/MainMenu.cpp \
    src/main.cpp \
    src/Log.cpp \
    src/image.cpp \
    src/GameState.cpp \
    src/Frustum.cpp \
    src/font.cpp \
    src/extensions.cpp \
    src/EnvironmentObject.cpp \
    src/Economy.cpp \
    src/Config.cpp \
    src/collisions.cpp \
    src/CityManager.cpp \
    src/CityEconomy.cpp \
    src/City.cpp \
    src/Camera.cpp \
    src/BoundBox.cpp \
    src/sound.cpp \
    src/Menu/MenuContainer.cpp \
    src/Menu/DataContainer.cpp \
    src/Menu/Button.cpp \
    src/StateBattle/Bullet.cpp \
    src/SoundStream.cpp \
    src/Cargo.cpp
HEADERS += src/Camera.h \
    src/ccmath.h \
    src/City.h \
    src/CityManager.h \
    src/collisions.h \
    src/Config.h \
    src/EnvironmentObject.h \
    src/extensions.h \
    src/font.h \
    src/Frustum.h \
    src/GameState.h \
    src/image.h \
    src/Log.h \
    src/MainMenu.h \
    src/Map.h \
    src/normals.h \
    src/Ocean.h \
    src/Player.h \
    src/Point.h \
    src/QuadBox.h \
    src/QuadNode.h \
    src/StateCity.h \
    src/StateSailing.h \
    src/Terrain.h \
    src/tinyxml.h \
    src/Wave.h \
    src/WaveEmitter.h \
    src/BoundBox.h \
    src/Model.h \
    src/Product.h \
    src/Callback.h \
    src/Economy.h \
    src/CityEconomy.h \
    src/SkyBox.h \
    src/Menu.h \
    src/StateBattle.h \
    src/Ships.h \
    src/WaveEmitter.h \
    src/Wave.h \
    src/tinyxml.h \
    src/tinystr.h \
    src/Terrain.h \
    src/StateSailing.h \
    src/StateCity.h \
    src/StateBattle.h \
    src/sound.h \
    src/SkyBox.h \
    src/Ships.h \
    src/QuadNode.h \
    src/QuadBox.h \
    src/Product.h \
    src/Point.h \
    src/Player.h \
    src/Ocean.h \
    src/normals.h \
    src/Model.h \
    src/Menu.h \
    src/Map.h \
    src/MainMenu.h \
    src/Log.h \
    src/image.h \
    src/GameState.h \
    src/Frustum.h \
    src/font.h \
    src/extensions.h \
    src/EnvironmentObject.h \
    src/Economy.h \
    src/Config.h \
    src/collisions.h \
    src/CityManager.h \
    src/CityEconomy.h \
    src/City.h \
    src/ccmath.h \
    src/Camera.h \
    src/Callback.h \
    src/BoundBox.h \
    src/sound.h \
    src/Menu/MenuContainer.h \
    src/Menu/DataContainer.h \
    src/Menu/Button.h \
    src/StateBattle/Bullet.h \
    src/SoundStream.h \
    src/Cargo.h
OTHER_FILES += build/data/background.png \
    build/data/background.psd \
    build/data/city.png \
    build/data/detail.png \
    build/data/font.png \
    build/data/land.png \
    build/data/loading \
    page.psd \
    build/data/loading.png \
    build/data/map.png \
    build/data/mapscreen.png \
    build/data/SaraCraft.conf \
    build/data/ship.vtx \
    build/data/water.png \
    src/QuadNode.o \
    src/QuadBox.o \
    src/Point.o \
    src/Player.o \
    src/Ocean.o \
    src/normals.o \
    src/Map.o \
    src/Makefile \
    src/MainMenu.o \
    src/main.o \
    src/Log.o \
    src/image.o \
    src/GameState.o \
    src/Frustum.o \
    src/font.o \
    src/extensions.o \
    src/EnvironmentObject.o \
    src/Config.o \
    src/collisions.o \
    src/CityManager.o \
    src/City.o \
    src/Camera.o
